
/***
    KX3-85.ino
    Tastatur für CW oder PSK.
    Der KX3 wurde ueber Menue 'RS232' auf 38400 Baud eingestellt
    In der Betriebsart CW, PSK, FSK wird der von der Tastatur
    eingegebene Text vom KX3 gesendet.
    (dj2jk 10.2018)

    Portiert auf Digispark bzw. ATtiny85. Geschwindigkeit auf
    38400 bit/s geändert (damit sich der ATtiny schneller wieder
    um die Tastatur kümmern kann). SoftwareSerial.h heisst beim 
    Digispark SoftSerial.h
*/

#include <PS2Keyboard.h>
PS2Keyboard keyboard;
const int DataPin = 0;
const int IRQPin = 2;        // muss interruptfähig sein

#include <SoftSerial.h>
#define RX 5                 // wird eigentlich nicht benötigt
#define TX 1
SoftSerial ss ( RX, TX, true);
String cmd;

void setup() {
  ss.begin(38400);           // KX3 Baudrate
  keyboard.begin(DataPin, IRQPin, PS2Keymap_German);
}

void loop() {
  if (keyboard.available()) {      // Zeichen von Tastatur da?
    char c = keyboard.read();      // Zeichen lesen
    if (c == 13) {                 // Return umcodieren
      c = 10;
    }
    cmd = ("KY" + (String)c + ";");   // Kommando zusammenbauen
    ss.print(cmd);                 // Kommando senden
  }
}
